/* canera support is disabled at the moment
// camera symbol, normally should be placed in blocks.js
SymbolMorph.prototype.names.push('camera');
//-- new Camera Symbol
SymbolMorph.prototype.drawSymbolCamera = function (canvas, color) {
    // answer a canvas showing a camera
    var ctx = canvas.getContext('2d'),
        w = canvas.width,
		h = canvas.height,
        l = Math.max(w / 20, 0.5);

    ctx.strokeStyle = color.toString();
	ctx.fillStyle = color.toString();
    ctx.lineWidth = l * 2;
	
	ctx.beginPath();
	//ctx.lineWidth=3;
	ctx.moveTo(4*l, 4*l);
	ctx.lineTo(w - 4*l, 4*l);
	ctx.quadraticCurveTo(w-l, 4*l, w-l, 8*l);
	ctx.lineTo(w-l, h - 8*l);
	ctx.quadraticCurveTo(w - l, h - 4*l, w - 4*l, h-4*l);
	ctx.lineTo(4*l, h-4*l);
	ctx.quadraticCurveTo(l, h - 4*l, l, h - 8*l);
	ctx.lineTo(l, 8*l);
	ctx.quadraticCurveTo(l, 4*l, 4*l, 4*l);
	ctx.stroke();

	ctx.beginPath();
	ctx.arc(w / 2 , h / 2 , (h - 8*l) / 5 , 0, 2 * Math.PI);
	ctx.stroke();
	ctx.fill();

	ctx.fillRect(w - 7*l , 6*l , 3*l,3*l);
	ctx.fillRect(4*l,l,4*l,4*l);
    
    return canvas;
};
//-- new CameraSymbol
originalSymbolMorphSymbolCanvasColored = SymbolMorph.prototype.symbolCanvasColored; 
SymbolMorph.prototype.symbolCanvasColored = function (aColor) {
	var canvas = newCanvas(new Point(this.symbolWidth(), this.size));
	if (this.name=='camera'){
		return this.drawSymbolCamera(canvas, aColor);
	} else {
		return originalSymbolMorphSymbolCanvasColored.call(this,aColor);
	}
}

// camera symbol

DialogBoxMorph.prototype.camDialog = function (
 title,
 world,
 pic
) {	
 if (!this.key) {
 this.key = 'decide' + title + 'camera';
 }

 this.labelString = title;
 this.createLabel();
 if (pic) {this.setPicture(pic); }
//
	if (this.buttons) {
        this.buttons.destroy();
    }
    this.buttons = new AlignmentMorph('column', this.padding);
    this.add(this.buttons);
// 
var alRow1,alRow2, alRow11, alRow111, alRow112, alRow121,
    zinbtn, zoutbtn, lbtn,rbtn,ubtn,dbtn,sbtn, okbtn,cbtn;
 zinbtn=this.addButton('zoomIn','+',true);
 zinbtn.fontSize=18;
// zinbtn.drawNew();
 zinbtn.fixLayout();
 zoutbtn=this.addButton('zoomOut','-',true);
 zoutbtn.fontSize=18;
// zoutbtn.drawNew();
 zoutbtn.fixLayout();
 lbtn=this.addButton('left', new SymbolMorph('arrowLeft',18),true);
 ubtn=this.addButton('up', new SymbolMorph('arrowUp',18),true);
 dbtn=this.addButton('down', new SymbolMorph('arrowDown',18),true);
 rbtn=this.addButton('right', new SymbolMorph('arrowRight',18),true);
 sbtn=this.addButton('save', new SymbolMorph('storage',18),true); //save as costume
 okbtn=this.addButton('ok', new SymbolMorph('camera',18),true);//Save on stage
 cbtn=this.addButton('cancel', 'Close',true);
 
 alRow1 = new AlignmentMorph('row', this.padding);
 alRow11 = new AlignmentMorph('column', this.padding);
  
 alRow111 = new AlignmentMorph('row', this.padding/3);
 alRow111.add(zinbtn);
 alRow111.add(zoutbtn);
 alRow111.fixLayout();
 alRow112 = new AlignmentMorph('row', this.padding/3);
 alRow112.add(sbtn);
 alRow112.add(okbtn);
 alRow112.fixLayout();
 alRow11.add(alRow111);
 alRow11.add(alRow112);
 alRow11.fixLayout();
 
 alRow121 = new AlignmentMorph('column', this.padding);
 alRow121.add(ubtn);
 alRow121.add(dbtn);
 alRow121.fixLayout(); 

 alRow1.add(alRow11);
 alRow1.add(lbtn);
 alRow1.add(alRow121);
 alRow1.add(rbtn);

 alRow1.fixLayout();
 
 alRow2 = new AlignmentMorph('row', this.padding);
 alRow2.add(cbtn);
 
 this.buttons.add(alRow1);
 this.buttons.add(alRow2);
 
 
 this.fixLayout();
 this.drawNew();
 this.fixLayout();
 this.popUp(world);
};
//new camera dialog box
*/

//===== Network SymbolMorph  && ConnectDialog=============
// normally should be placed in blocks.js
SymbolMorph.prototype.names.push('network');

SymbolMorph.prototype.drawSymbolNetwork = function (canvas, color) {
    // answer a canvas showing a camera
    var ctx = canvas.getContext('2d'),
        w = 2*Math.min(canvas.width, canvas.height) / 3,
        l = Math.max(w / 20, 0.5);

    ctx.strokeStyle = color.toString();
	ctx.fillStyle = color.toString();
    ctx.lineWidth = l * 2;

	ctx.fillRect((canvas.width - w) /2 , 0, w, 3*w/4);
	ctx.moveTo((canvas.width - w) / 2 - 2*l, 3*w/4 -l);
	ctx.lineTo((canvas.width + w) / 2 + 2*l, 3*w/4 -l);
	ctx.moveTo(canvas.width / 2, 2*l + 3*w/4);
	ctx.lineTo(canvas.width / 2, canvas.height - 2*l);
	ctx.moveTo(0, canvas.height);
	ctx.lineWidth = l * 4;
	ctx.lineTo(canvas.width, canvas.height);
	ctx.stroke();
	
    return canvas;
};

originalSymbolMorphSymbolCanvasColored = SymbolMorph.prototype.symbolCanvasColored; 
SymbolMorph.prototype.symbolCanvasColored = function (aColor) {
	var canvas = newCanvas(new Point(this.symbolWidth(), this.size));
	if (this.name=='network'){
		return this.drawSymbolNetwork(canvas, aColor);
	} else {
		return originalSymbolMorphSymbolCanvasColored.call(this,aColor);
	}
}
// Network SymbolMorph
DialogBoxMorph.prototype.netConnectDialog = function (world) {
	var frame = new AlignmentMorph("column", 2),
		address = new InputFieldMorph(),
		nickName = new InputFieldMorph();
	
	function labelText(string) {
        return new TextMorph(
            localize(string),
            10,
            null, // style
            false, // bold
            null, // italic
            null, // alignment
            null, // width
            null, // font name
            MorphicPreferences.isFlat ? null : new Point(1, 1),
            new Color(255, 255, 255) // shadowColor
        );
    }
	
	this.getInput = function () {
        return {
            serverAddress: address.getValue(),
            nickName: nickName.getValue()
        };
    };
	
	if (!this.key) {
		this.key = 'decide network';
	}
	this.labelString = "Connect to Network";
	this.createLabel();
	
	frame.alignment = 'left';
    frame.setColor(this.color);
	address.setWidth(200);
	nickName.setWidth(100);
	
	frame.add(labelText('Server Name or IP'));
    frame.add(address);
	frame.add(labelText('NickName'));
    frame.add(nickName);
	frame.fixLayout();
	this.addBody(frame);
	address.drawNew();
	nickName.drawNew();
	frame.fixLayout();
	 
	this.addButton('ok', 'OK');
	this.addButton('cancel', 'Cancel');
	this.fixLayout();
	this.drawNew();
	this.fixLayout();
	this.popUp(world);
	address.edit();
};

// ============= Network Symbol and ConnectDialog==================

/*
DialogBoxMorph.prototype.addButton = function (action, label, justCreate) {
    var button = new PushButtonMorph(
        this,
        action || 'ok',
        (label instanceof SymbolMorph ) ? label : ('  ' + localize((label || 'OK')) + '  ')
    );
    button.fontSize = this.buttonFontSize;
    button.corner = this.buttonCorner;
    button.edge = this.buttonEdge;
    button.outline = this.buttonOutline;
    button.outlineColor = this.buttonOutlineColor;
    button.outlineGradient = this.buttonOutlineGradient;
    button.padding = this.buttonPadding;
    button.contrast = this.buttonContrast;
    button.drawNew();
    button.fixLayout();
	if (!justCreate){ //++ camDialog
			this.buttons.add(button);
	}
    return button;
};
*/
// DialogBoxMorph layout

DialogBoxMorph.prototype.fixLayout = function () {
    var th = fontHeight(this.titleFontSize) + this.titlePadding * 2, w;

    if (this.head) {
        this.head.setPosition(this.position().add(new Point(
            this.padding,
            th + this.padding
        )));
        this.silentSetWidth(this.head.width() + this.padding * 2); 
        this.silentSetHeight(
            this.head.height()
                + this.padding * 2
                + th
        );
    }

    if (this.body) {
        if (this.head) {
            this.body.setPosition(this.head.bottomLeft().add(new Point(
                0,
                this.padding
            )));
            this.silentSetWidth(Math.max(
                this.width(),
                this.body.width() + this.padding * 2
            ));
            this.silentSetHeight(
                this.height()
                    + this.body.height()
                    + this.padding
            );
            w = this.width();
            this.head.setLeft(
                this.left()
                    + Math.round((w - this.head.width()) / 2)
            );
            this.body.setLeft(
                this.left()
                    + Math.round((w - this.body.width()) / 2)
            );
        } else {
            this.body.setPosition(this.position().add(new Point(
                this.padding,
                th + this.padding
            )));
            this.silentSetWidth(//this.body.width() + this.padding * 2);
				Math.max(
                (this.label ? this.label.width() : 0 )+ this.padding * 2,
                this.body.width() + this.padding * 2
            )
			);
            this.silentSetHeight(
                this.body.height()
                    + this.padding * 2
                    + th
            );
        }
    }
   
    if (this.buttons && (this.buttons.children.length > 0)) {
        this.buttons.fixLayout();
		this.silentSetWidth(Math.max(             //+++ fix width if buttons are wider than text
                this.width(),
                this.buttons.width() + this.padding * 2));
        this.silentSetHeight(
            this.height()
                    + this.buttons.height()
                    + this.padding
        );
        this.buttons.setCenter(this.center());
        this.buttons.setBottom(this.bottom() - this.padding);
    }

	if (this.label) {
        this.label.setCenter(this.center());
        this.label.setTop(this.top() + (th - this.label.height()) / 2);
    }
};