<?php
define( '_JEXEC', 1 );
require_once '../config.php';
//function that corrects the path, cleaning redudant separators. Taken from Joomla core.
function clean($path, $ds = DIRECTORY_SEPARATOR)
	{
		if (!is_string($path) && !empty($path))
		{
			throw new UnexpectedValueException('JPath::clean: $path is not a string.');
		}

		$path = trim($path);

		if (empty($path))
		{
			$path = JPATH_ROOT;
		}
		// Remove double slashes and backslashes and convert all slashes and backslashes to DIRECTORY_SEPARATOR
		// If dealing with a UNC path don't forget to prepend the path with a backslash.
		elseif (($ds == '\\') && substr($path, 0, 2) == '\\\\')
		{
			$path = "\\" . preg_replace('#[/\\\\]+#', $ds, $path);
		}
		else
		{
			$path = preg_replace('#[/\\\\]+#', $ds, $path);
		}

		return $path;
	}
	
define ('JPATH_BASE', clean( '/users/userswww2/e/e/haritop/public_html'.JOOMLA_PATH));	

require_once ( clean(JPATH_BASE .'/includes/defines.php' ));
require_once ( clean(JPATH_BASE .'/includes/framework.php' ));
require_once( JPATH_LIBRARIES.'/cms/component/helper.php');

function check_user()
	{
		//if the component exists and it is enabled
		if (JComponentHelper::getComponent('com_snaphe_cloud', true)->enabled){
		//get the component helper path, and initialize the application
			require_once(JPATH_ADMINISTRATOR . '/components/com_snaphe_cloud/helpers/snaphe_cloud.php');
		//check the path of the active user
			return Snaphe_cloudHelper::checkUser();		
		} 
		//else -> component not found
		return '';
	}

?>