//disableRetinaSupport();

function indexOf(array, el){          //find an element in an array
for (i=0; i<array.length; i++)
if (array[i].toString()==el.toString()) { return i;}
return -1;
}		

originalMorphInit = Morph.prototype.init;

Morph.prototype.init = function (noDraw) {
    originalMorphInit.call(this,noDraw);
    this.isHidden = false;  // for hidding scripts
};

// -------- modified hide - show functions ----------------------------
Morph.prototype.hide = function (student) {
if (this.parentThatIsA(InputSlotDialogMorph)){ //if you are in parameter type definition
    this.isVisible = false;
    this.changed();
    return;
}    
if ((this instanceof SyntaxElementMorph || this.parentThatIsA(SyntaxElementMorph)/*this.parent instanceof BlockMorph || this.parent instanceof InputSlotMorph */)  && !student) // && world.role !== 'STUDENT'
 {
 //   this.isVisible=true;
	if (this.alpha==1) {this.alpha =0.4;}
	} else {this.isVisible = false;}
    this.changed();
this.isHidden = true;
if (this instanceof MultiArgMorph && this.children.length <3) { return;}  //@@@@@@@@@@@@@@@@@ nasty MultiArgsMorph bug
    this.children.forEach(function (child) {
       child.hide();//}
    });
};

Morph.prototype.show = function () {
var myself =this;

if (this.alpha==0.4) 
{this.alpha =1 ;}
this.isVisible=true;
this.isHidden=false;
    this.changed();
if (this instanceof MultiArgMorph && this.children.length <3) { return;}  //@@@@@@@@@@@@@@@@@ nasty MultiArgsMorph bug
    this.children.forEach(function (child) {
        child.show(); //}
    });
};
//-------------------------------------------------------------------------------------
// for not localizing contents
MenuMorph.prototype.addItem = function (
    labelString,
    action,
    hint,
    color,
    bold, // bool
    italic, // bool
    doubleClickAction, // optional, when used as list contents
	notLocal, //++++++++++++++++++ if true, don't localize contents
    shortcut // optional string, icon (Morph or Canvas) or tuple [icon, string]            
) {
    /*
    labelString is normally a single-line string. But it can also be one
    of the following:

        * a multi-line string (containing line breaks)
        * an icon (either a Morph or a Canvas)
        * a tuple of format: [icon, string]
    */
//+++++++++++++++++++++++++++ choose contents according to the 'notLocal' value
var label;
label=localize(labelString || 'close');
if (notLocal) {label = labelString || 'close';} 
//+++++++++++++++++++++++
	this.items.push([
		label,//localize(labelString || 'close'), //------------------------------
        action || nop,
        hint,
        color,
        bold || false,
        italic || false,
        doubleClickAction,
        shortcut]);
};

MenuMorph.prototype.addPair = function (label, action, shortcut, hint) {
    this.addItem(label, action, hint, null, null, null, null, null, shortcut);
};

//prevent from dropping exrernal files, images and audio in HOC mode
originalHandMorphProcessDrop=HandMorph.prototype.processDrop;
HandMorph.prototype.processDrop = function (event,forced) {  
    if (this.world.HOCmode && !forced){ //forced comes from import menu selection
        return;
    }
    originalHandMorphProcessDrop.call(this,event);
}
/*
// don' ask exit confirmattion in HOC mode
originalInitEventListeners = WorldMorph.prototype.initEventListeners;
WorldMorph.prototype.initEventListeners = function () {
    var myself = this;
	originalInitEventListeners.call(this);
	window.onbeforeunload = function (evt) {
		var e = evt || window.event,
			msg = "Are you sure you want to leave?";
		// For IE and Firefox
		//if (myself.HOCmode) {return;} //+++ Hour Of Code mode. No exit confirmation
		if (e) {
			e.returnValue = msg;
		}
		// For Safari / chrome
		return msg;
	};
}
*/